/* Problem URL: https://codeforces.com/gym/102346/problem/M */

#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, c, t;
    cin >> n >> c >> t;

    vi pop(n);

    repv(i, pop) {
        cin >> i;
        // i = (i + (t - 1)) / t;
    }

    ll ans = 1;
    ll low = 1;
    ll high = 1e9;

    while (low <= high) {
        ll mid = (low + high) / 2;

        int count = 1;
        ll now = 0;

        rep(i, n) {
            if ((pop[i] + (t - 1)) / t > mid) {
                now = 1e9 + 1;
                break;
            }

            now += pop[i];

            if ((now + (t - 1)) / t > mid) {
                if (count == c) {
                    break;
                }

                count++;
                now = pop[i];
            }
        }

        if ((now + (t - 1)) / t <= mid) {
            ans = mid;
            high = mid - 1;
            continue;
        }

        low = mid + 1;
    }

    cout << ans << '\n';
}
